Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml	(revision 13517)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml	(revision 13518)
@@ -48,6 +48,6 @@
                           Width="200" Margin="5,0,0,0"
                           SelectionChanged="ComboBoxPolicies_OnSelectionChanged"></ComboBox>
-                <TextBlock Name="TextBlockEpsylon" Text="Epsylon:" Visibility="Hidden" Margin="5,0,0,0" VerticalAlignment="Center"></TextBlock>
-                <TextBox Name="TextBoxEpsylon" Text="{Binding Epsylon}" Visibility="Hidden" Margin="5,0,0,0" VerticalAlignment="Center" Width="50"></TextBox>
+                <TextBlock Name="TextBlockEpsylon" Text="PolicyParameter:" Visibility="Hidden" Margin="5,0,0,0" VerticalAlignment="Center"></TextBlock>
+                <TextBox Name="TextBoxEpsylon" Text="{Binding PolicyParameter}" Visibility="Hidden" Margin="5,0,0,0" VerticalAlignment="Center" Width="50"></TextBox>
                 <Button Name="ButtonRun" Margin="5,0,0,0" Click="ButtonRun_OnClick" Height="22" VerticalAlignment="Top">Run</Button>
                 <Button Name="ButtonPause" Margin="5,0,0,0" Click="ButtonPause_OnClick" IsEnabled="False">Pause</Button>
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml.cs	(revision 13517)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml.cs	(revision 13518)
@@ -1,3 +1,4 @@
 ﻿using System.Collections.ObjectModel;
+using System.Globalization;
 using System.Security.AccessControl;
 using System.Text;
@@ -192,5 +193,5 @@
             if (policy == typeof(UCTPolicy))
             {
-                policyInstance = new UCTPolicy(vm.Epsylon);
+                policyInstance = new UCTPolicy(vm.PolicyParameter);
             }
             else if (policy == typeof(ThresholdAscentPolicy))
@@ -204,5 +205,5 @@
             else if (policy == typeof(EpsGreedyPolicy))
             {
-                policyInstance = new EpsGreedyPolicy(vm.Epsylon);
+                policyInstance = new EpsGreedyPolicy(vm.PolicyParameter);
             }
             else
@@ -457,6 +458,6 @@
             {
                 TextBoxEpsylon.Visibility = Visibility.Visible;
-                TextBoxEpsylon.Text = Math.Sqrt(1).ToString();
-                TextBlockEpsylon.Text = "Epsylon";
+                vm.PolicyParameter = 0.5;                
+                TextBlockEpsylon.Text = "Epsilon";
                 TextBlockEpsylon.Visibility = Visibility.Visible;
             }
@@ -464,5 +465,5 @@
             {
                 TextBoxEpsylon.Visibility = Visibility.Visible;
-                TextBoxEpsylon.Text = Math.Sqrt(2).ToString();
+                vm.PolicyParameter = Math.Sqrt(2);
                 TextBlockEpsylon.Text = "c";
                 TextBlockEpsylon.Visibility = Visibility.Visible;
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/ViewModel/EvaluationViewModel.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/ViewModel/EvaluationViewModel.cs	(revision 13517)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/ViewModel/EvaluationViewModel.cs	(revision 13518)
@@ -122,13 +122,13 @@
         }
 
-        private double epsylon;
-
-        public double Epsylon
-        {
-            get { return this.epsylon; }
-            set
-            {
-                this.epsylon = value;
-                this.OnPropertyChanged("Epsylon");
+        private double _policyParameter;
+
+        public double PolicyParameter
+        {
+            get { return this._policyParameter; }
+            set
+            {
+                this._policyParameter = value;
+                this.OnPropertyChanged("PolicyParameter");
             }
         }