Index: branches/thasling/DistributedGA/DistributedGA.ContactServer.Host/obj/Debug/DistributedGA.ContactServer.Host.csproj.FileListAbsolute.txt
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.ContactServer.Host/obj/Debug/DistributedGA.ContactServer.Host.csproj.FileListAbsolute.txt	(revision 13536)
+++ branches/thasling/DistributedGA/DistributedGA.ContactServer.Host/obj/Debug/DistributedGA.ContactServer.Host.csproj.FileListAbsolute.txt	(revision 13537)
@@ -19,2 +19,12 @@
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.ContactServer.Host\obj\Debug\DistributedGA.ContactServer.Host.exe
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.ContactServer.Host\obj\Debug\DistributedGA.ContactServer.Host.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\bin\Debug\DistributedGA.ContactServer.Host.exe.config
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\obj\Debug\DistributedGA.ContactServer.Host.exe
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\obj\Debug\DistributedGA.ContactServer.Host.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\bin\Debug\DistributedGA.ContactServer.Host.exe
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\bin\Debug\DistributedGA.ContactServer.Host.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\bin\Debug\DistributedGA.ContactServer.dll
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\bin\Debug\DistributedGA.Core.dll
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\bin\Debug\DistributedGA.ContactServer.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\bin\Debug\DistributedGA.Core.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer.Host\obj\Debug\DistributedGA.ContactServer.Host.csprojResolveAssemblyReference.cache
Index: branches/thasling/DistributedGA/DistributedGA.ContactServer/obj/Debug/DistributedGA.ContactServer.csproj.FileListAbsolute.txt
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.ContactServer/obj/Debug/DistributedGA.ContactServer.csproj.FileListAbsolute.txt	(revision 13536)
+++ branches/thasling/DistributedGA/DistributedGA.ContactServer/obj/Debug/DistributedGA.ContactServer.csproj.FileListAbsolute.txt	(revision 13537)
@@ -15,2 +15,10 @@
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.ContactServer\obj\Debug\DistributedGA.ContactServer.dll
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.ContactServer\obj\Debug\DistributedGA.ContactServer.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer\bin\Debug\DistributedGA.ContactServer.dll.config
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer\bin\Debug\DistributedGA.ContactServer.dll
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer\bin\Debug\DistributedGA.ContactServer.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer\bin\Debug\DistributedGA.Core.dll
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer\bin\Debug\DistributedGA.Core.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer\obj\Debug\DistributedGA.ContactServer.csprojResolveAssemblyReference.cache
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer\obj\Debug\DistributedGA.ContactServer.dll
+C:\Public\SVN\DistributedGA\DistributedGA.ContactServer\obj\Debug\DistributedGA.ContactServer.pdb
Index: branches/thasling/DistributedGA/DistributedGA.ContactServer/obj/Debug/WcfConfigValidationData.tmp
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.ContactServer/obj/Debug/WcfConfigValidationData.tmp	(revision 13536)
+++ branches/thasling/DistributedGA/DistributedGA.ContactServer/obj/Debug/WcfConfigValidationData.tmp	(revision 13537)
@@ -1,1 +1,1 @@
-<ValidationRecord xmlns="http://schemas.datacontract.org/2004/07/Microsoft.VisualStudio.ServiceModel.Validation" xmlns:i="http://www.w3.org/2001/XMLSchema-instance"><TimeStamps xmlns:a="http://schemas.microsoft.com/2003/10/Serialization/Arrays"><a:dateTime>2016-01-16T10:21:59.3448568Z</a:dateTime><a:dateTime>2016-01-17T10:06:16.6796006Z</a:dateTime><a:dateTime>2016-01-09T12:27:02.4072628Z</a:dateTime></TimeStamps></ValidationRecord>
+<ValidationRecord xmlns="http://schemas.datacontract.org/2004/07/Microsoft.VisualStudio.ServiceModel.Validation" xmlns:i="http://www.w3.org/2001/XMLSchema-instance"><TimeStamps xmlns:a="http://schemas.microsoft.com/2003/10/Serialization/Arrays"><a:dateTime>2016-01-18T09:27:09.7709563Z</a:dateTime><a:dateTime>2016-01-18T09:31:18.4519841Z</a:dateTime><a:dateTime>2015-04-01T13:05:26.8346639Z</a:dateTime></TimeStamps></ValidationRecord>
Index: branches/thasling/DistributedGA/DistributedGA.Core.Host/Program.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core.Host/Program.cs	(revision 13536)
+++ branches/thasling/DistributedGA/DistributedGA.Core.Host/Program.cs	(revision 13537)
@@ -1,82 +1,64 @@
-﻿using DistributedGA.Core.Domain;
+﻿using System;
+using System.Threading;
+using DistributedGA.Core.Domain;
 using DistributedGA.Core.Implementation;
 using DistributedGA.Core.Interface;
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading;
-using System.Threading.Tasks;
 
-namespace DistributedGA.Core.Host
-{
-    class Program
-    {
-        static void Main(string[] args)
-        {
-            try
-            {
-                Console.WriteLine("Starting peer...");
-                IMessageHandler h = new PeerNetworkMessageHandler();
-                h.Init();
-                PeerInfo pi = h.GetPeerInfo();
-                Console.WriteLine(string.Format("Peer is hostet at IP: {0} and port: {1}", pi.IpAddress, pi.Port));
-                Thread.Sleep(1000 * 20);
-                Console.WriteLine("Current peers within network:");
-                foreach (var item in h.GetCurrentNetwork())
-                {
-                    Console.WriteLine(string.Format("Peer at {0}:{1}",item.IpAddress, item.Port));
-                }
-                while (true)
-                {
-                    Thread.Sleep(1000 * 10);
-                    var pop1 = CreatePopulation();
-                    Console.WriteLine("Publish population into network...");
-                    h.PublishMigrationInfo(pop1);
-                    Console.WriteLine("Population published.");
-                    Console.WriteLine("Recieved populations:");
-                    foreach (var item in h.GetMigrationInfo())
-                    {
-                        Console.WriteLine(string.Format("Population with Quality: {0:2} in Iteration {1}", item.Quality, item.IterationNumber));
-                    }
-                }
-            }
-            catch (Exception ex)
-            {
-                Console.WriteLine(ex.Message);
-                Console.WriteLine("press any key to continue...");
-                Console.ReadLine();
-            }
+namespace DistributedGA.Core.Host {
+  class Program {
+    static void Main(string[] args) {
+      try {
+        Console.WriteLine("Starting peer...");
+        IMessageHandler h = new PeerNetworkMessageHandler();
+        h.Init();
+        PeerInfo pi = h.GetPeerInfo();
+        Console.WriteLine(string.Format("Peer is hostet at IP: {0} and port: {1}", pi.IpAddress, pi.Port));
+        Thread.Sleep(1000 * 20);
+        Console.WriteLine("Current peers within network:");
+        foreach (var item in h.GetCurrentNetwork()) {
+          Console.WriteLine(string.Format("Peer at {0}:{1}", item.IpAddress, item.Port));
+        }
+        int i = 1;
+        while (i < 10) {
+          i++;
+          Thread.Sleep(1000 * 10);
+          var pop1 = CreatePopulation();
+          Console.WriteLine("Publish population into network...");
+          h.PublishMigrationInfo(pop1);
+          Console.WriteLine("Population published.");
+          Console.WriteLine("Recieved populations:");
+          foreach (var item in h.GetMigrationInfo()) {
+            Console.WriteLine(string.Format("Population with Quality: {0:2} in Iteration {1}", item.Quality, item.IterationNumber));
+          }
+        }
+      } catch (Exception ex) {
+        Console.WriteLine(ex.Message);
+        Console.WriteLine("press any key to continue...");
+        Console.ReadLine();
+      }
 
+    }
+
+    private static SolutionInfo[] CreatePopulation() {
+      SolutionInfo si1 = new SolutionInfo() {
+        IterationNumber = 1,
+        Quality = 3.5f,
+        Solution = new Solution() {
         }
-
-        private static SolutionInfo[] CreatePopulation()
-        {
-            SolutionInfo si1 = new SolutionInfo()
-            {
-                IterationNumber = 1,
-                Quality = 3.5f,
-                Solution = new Solution()
-                {
-                }
-            };
-            SolutionInfo si2 = new SolutionInfo()
-            {
-                IterationNumber = 2,
-                Quality = 3.5f,
-                Solution = new Solution()
-                {
-                }
-            };
-            SolutionInfo si3 = new SolutionInfo()
-            {
-                IterationNumber = 3,
-                Quality = 3.5f,
-                Solution = new Solution()
-                {
-                }
-            };
-            return new SolutionInfo[] { si1, si2, si3 };
+      };
+      SolutionInfo si2 = new SolutionInfo() {
+        IterationNumber = 2,
+        Quality = 3.5f,
+        Solution = new Solution() {
         }
+      };
+      SolutionInfo si3 = new SolutionInfo() {
+        IterationNumber = 3,
+        Quality = 3.5f,
+        Solution = new Solution() {
+        }
+      };
+      return new SolutionInfo[] { si1, si2, si3 };
     }
+  }
 }
Index: branches/thasling/DistributedGA/DistributedGA.Core.Host/obj/Debug/DistributedGA.Core.Host.csproj.FileListAbsolute.txt
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core.Host/obj/Debug/DistributedGA.Core.Host.csproj.FileListAbsolute.txt	(revision 13536)
+++ branches/thasling/DistributedGA/DistributedGA.Core.Host/obj/Debug/DistributedGA.Core.Host.csproj.FileListAbsolute.txt	(revision 13537)
@@ -15,2 +15,10 @@
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.Core.Host\obj\Debug\DistributedGA.Core.Host.exe
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.Core.Host\obj\Debug\DistributedGA.Core.Host.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.Core.Host\bin\Debug\DistributedGA.Core.Host.exe.config
+C:\Public\SVN\DistributedGA\DistributedGA.Core.Host\obj\Debug\DistributedGA.Core.Host.exe
+C:\Public\SVN\DistributedGA\DistributedGA.Core.Host\obj\Debug\DistributedGA.Core.Host.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.Core.Host\bin\Debug\DistributedGA.Core.Host.exe
+C:\Public\SVN\DistributedGA\DistributedGA.Core.Host\bin\Debug\DistributedGA.Core.Host.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.Core.Host\bin\Debug\DistributedGA.Core.dll
+C:\Public\SVN\DistributedGA\DistributedGA.Core.Host\bin\Debug\DistributedGA.Core.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.Core.Host\obj\Debug\DistributedGA.Core.Host.csprojResolveAssemblyReference.cache
Index: branches/thasling/DistributedGA/DistributedGA.Core/obj/Debug/DistributedGA.Core.csproj.FileListAbsolute.txt
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/obj/Debug/DistributedGA.Core.csproj.FileListAbsolute.txt	(revision 13536)
+++ branches/thasling/DistributedGA/DistributedGA.Core/obj/Debug/DistributedGA.Core.csproj.FileListAbsolute.txt	(revision 13537)
@@ -8,2 +8,7 @@
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.Core\obj\Debug\DistributedGA.Core.dll
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.Core\obj\Debug\DistributedGA.Core.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.Core\bin\Debug\DistributedGA.Core.dll
+C:\Public\SVN\DistributedGA\DistributedGA.Core\bin\Debug\DistributedGA.Core.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.Core\obj\Debug\DistributedGA.Core.csprojResolveAssemblyReference.cache
+C:\Public\SVN\DistributedGA\DistributedGA.Core\obj\Debug\DistributedGA.Core.dll
+C:\Public\SVN\DistributedGA\DistributedGA.Core\obj\Debug\DistributedGA.Core.pdb
Index: branches/thasling/DistributedGA/DistributedGA.Test/obj/Debug/DistributedGA.Test.csproj.FileListAbsolute.txt
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Test/obj/Debug/DistributedGA.Test.csproj.FileListAbsolute.txt	(revision 13536)
+++ branches/thasling/DistributedGA/DistributedGA.Test/obj/Debug/DistributedGA.Test.csproj.FileListAbsolute.txt	(revision 13537)
@@ -21,2 +21,5 @@
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.Test\obj\Debug\DistributedGA.Test.exe
 P:\_DATA\SVN\thasling\DistributedGA\DistributedGA.Test\obj\Debug\DistributedGA.Test.pdb
+C:\Public\SVN\DistributedGA\DistributedGA.Test\bin\Debug\DistributedGA.Test.exe.config
+C:\Public\SVN\DistributedGA\DistributedGA.Test\obj\Debug\DistributedGA.Test.exe
+C:\Public\SVN\DistributedGA\DistributedGA.Test\obj\Debug\DistributedGA.Test.pdb