Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Views/3.3/ExpertSystemView.Designer.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Views/3.3/ExpertSystemView.Designer.cs	(revision 13485)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Views/3.3/ExpertSystemView.Designer.cs	(revision 13551)
@@ -34,5 +34,4 @@
     /// </summary>
     private void InitializeComponent() {
-      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ExpertSystemView));
       this.evaluationsLimitabel = new System.Windows.Forms.Label();
       this.maxEvaluationsTextBox = new System.Windows.Forms.TextBox();
@@ -40,6 +39,4 @@
       this.problemTabPage = new System.Windows.Forms.TabPage();
       this.problemViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.openProblemButton = new System.Windows.Forms.Button();
-      this.newProblemButton = new System.Windows.Forms.Button();
       this.algorithmTabPage = new System.Windows.Forms.TabPage();
       this.algorithmViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
@@ -47,6 +44,7 @@
       this.suggestedInstancesComboBox = new System.Windows.Forms.ComboBox();
       this.runsTabPage = new System.Windows.Forms.TabPage();
+      this.runsView = new HeuristicLab.Optimization.Views.RunCollectionView();
       this.okbTabPage = new System.Windows.Forms.TabPage();
-      this.algorithmInstancesViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.kbViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.problemInstancesTabPage = new System.Windows.Forms.TabPage();
       this.problemInstancesView = new HeuristicLab.MainForm.WindowsForms.ViewHost();
@@ -54,8 +52,8 @@
       this.dragFLAHereLabel = new System.Windows.Forms.Label();
       this.refreshMapButton = new System.Windows.Forms.Button();
+      this.progressPanel = new System.Windows.Forms.Panel();
+      this.okbDownloadButton = new System.Windows.Forms.Button();
       this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
-      this.okbDownloadButton = new System.Windows.Forms.Button();
-      this.runsView = new HeuristicLab.Optimization.Views.RunCollectionView();
-      this.progressPanel = new System.Windows.Forms.Panel();
+      this.algorithmStartButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.tabControl.SuspendLayout();
@@ -90,5 +88,5 @@
       // maxEvaluationsTextBox
       // 
-      this.maxEvaluationsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.maxEvaluationsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.maxEvaluationsTextBox.Location = new System.Drawing.Point(75, 26);
@@ -101,6 +99,6 @@
       // 
       this.tabControl.AllowDrop = true;
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.tabControl.Controls.Add(this.problemTabPage);
@@ -109,8 +107,8 @@
       this.tabControl.Controls.Add(this.okbTabPage);
       this.tabControl.Controls.Add(this.problemInstancesTabPage);
-      this.tabControl.Location = new System.Drawing.Point(0, 52);
+      this.tabControl.Location = new System.Drawing.Point(0, 81);
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(546, 361);
+      this.tabControl.Size = new System.Drawing.Size(546, 332);
       this.tabControl.TabIndex = 17;
       // 
@@ -119,57 +117,29 @@
       this.problemTabPage.AllowDrop = true;
       this.problemTabPage.Controls.Add(this.problemViewHost);
-      this.problemTabPage.Controls.Add(this.openProblemButton);
-      this.problemTabPage.Controls.Add(this.newProblemButton);
       this.problemTabPage.Location = new System.Drawing.Point(4, 22);
       this.problemTabPage.Name = "problemTabPage";
       this.problemTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.problemTabPage.Size = new System.Drawing.Size(538, 335);
+      this.problemTabPage.Size = new System.Drawing.Size(538, 306);
       this.problemTabPage.TabIndex = 1;
       this.problemTabPage.Text = "Problem";
       this.problemTabPage.UseVisualStyleBackColor = true;
-      this.problemTabPage.DragDrop += new System.Windows.Forms.DragEventHandler(this.problemTabPage_DragDrop);
-      this.problemTabPage.DragEnter += new System.Windows.Forms.DragEventHandler(this.problemTabPage_DragEnterOver);
-      this.problemTabPage.DragOver += new System.Windows.Forms.DragEventHandler(this.problemTabPage_DragEnterOver);
       // 
       // problemViewHost
       // 
-      this.problemViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
       this.problemViewHost.Caption = "View";
       this.problemViewHost.Content = null;
+      this.problemViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
       this.problemViewHost.Enabled = false;
-      this.problemViewHost.Location = new System.Drawing.Point(6, 36);
+      this.problemViewHost.Location = new System.Drawing.Point(3, 3);
       this.problemViewHost.Name = "problemViewHost";
       this.problemViewHost.ReadOnly = false;
-      this.problemViewHost.Size = new System.Drawing.Size(526, 293);
+      this.problemViewHost.Size = new System.Drawing.Size(532, 300);
       this.problemViewHost.TabIndex = 2;
-      this.problemViewHost.ViewsLabelVisible = true;
+      this.problemViewHost.ViewsLabelVisible = false;
       this.problemViewHost.ViewType = null;
       // 
-      // openProblemButton
-      // 
-      this.openProblemButton.Image = ((System.Drawing.Image)(resources.GetObject("openProblemButton.Image")));
-      this.openProblemButton.Location = new System.Drawing.Point(36, 6);
-      this.openProblemButton.Name = "openProblemButton";
-      this.openProblemButton.Size = new System.Drawing.Size(24, 24);
-      this.openProblemButton.TabIndex = 1;
-      this.toolTip.SetToolTip(this.openProblemButton, "Open Problem");
-      this.openProblemButton.UseVisualStyleBackColor = true;
-      this.openProblemButton.Click += new System.EventHandler(this.openProblemButton_Click);
-      // 
-      // newProblemButton
-      // 
-      this.newProblemButton.Image = ((System.Drawing.Image)(resources.GetObject("newProblemButton.Image")));
-      this.newProblemButton.Location = new System.Drawing.Point(6, 6);
-      this.newProblemButton.Name = "newProblemButton";
-      this.newProblemButton.Size = new System.Drawing.Size(24, 24);
-      this.newProblemButton.TabIndex = 0;
-      this.toolTip.SetToolTip(this.newProblemButton, "New Problem");
-      this.newProblemButton.UseVisualStyleBackColor = true;
-      this.newProblemButton.Click += new System.EventHandler(this.newProblemButton_Click);
-      // 
       // algorithmTabPage
       // 
+      this.algorithmTabPage.Controls.Add(this.algorithmStartButton);
       this.algorithmTabPage.Controls.Add(this.algorithmViewHost);
       this.algorithmTabPage.Controls.Add(this.algorithmSuggestionLabel);
@@ -178,5 +148,5 @@
       this.algorithmTabPage.Name = "algorithmTabPage";
       this.algorithmTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.algorithmTabPage.Size = new System.Drawing.Size(538, 335);
+      this.algorithmTabPage.Size = new System.Drawing.Size(538, 306);
       this.algorithmTabPage.TabIndex = 4;
       this.algorithmTabPage.Text = "Algorithm";
@@ -185,6 +155,6 @@
       // algorithmViewHost
       // 
-      this.algorithmViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.algorithmViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.algorithmViewHost.Caption = "View";
@@ -194,5 +164,5 @@
       this.algorithmViewHost.Name = "algorithmViewHost";
       this.algorithmViewHost.ReadOnly = false;
-      this.algorithmViewHost.Size = new System.Drawing.Size(526, 293);
+      this.algorithmViewHost.Size = new System.Drawing.Size(526, 264);
       this.algorithmViewHost.TabIndex = 2;
       this.algorithmViewHost.ViewsLabelVisible = true;
@@ -210,5 +180,5 @@
       // suggestedInstancesComboBox
       // 
-      this.suggestedInstancesComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.suggestedInstancesComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.suggestedInstancesComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
@@ -216,7 +186,6 @@
       this.suggestedInstancesComboBox.Location = new System.Drawing.Point(178, 6);
       this.suggestedInstancesComboBox.Name = "suggestedInstancesComboBox";
-      this.suggestedInstancesComboBox.Size = new System.Drawing.Size(354, 21);
+      this.suggestedInstancesComboBox.Size = new System.Drawing.Size(322, 21);
       this.suggestedInstancesComboBox.TabIndex = 0;
-      this.suggestedInstancesComboBox.SelectedIndexChanged += new System.EventHandler(this.suggestedInstancesComboBox_SelectedIndexChanged);
       // 
       // runsTabPage
@@ -226,37 +195,44 @@
       this.runsTabPage.Name = "runsTabPage";
       this.runsTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.runsTabPage.Size = new System.Drawing.Size(538, 335);
+      this.runsTabPage.Size = new System.Drawing.Size(538, 306);
       this.runsTabPage.TabIndex = 3;
       this.runsTabPage.Text = "Runs";
       this.runsTabPage.UseVisualStyleBackColor = true;
       // 
+      // runsView
+      // 
+      this.runsView.Caption = "RunCollection View";
+      this.runsView.Content = null;
+      this.runsView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.runsView.Location = new System.Drawing.Point(3, 3);
+      this.runsView.Name = "runsView";
+      this.runsView.ReadOnly = false;
+      this.runsView.Size = new System.Drawing.Size(532, 300);
+      this.runsView.TabIndex = 1;
+      // 
       // okbTabPage
       // 
-      this.okbTabPage.Controls.Add(this.progressPanel);
-      this.okbTabPage.Controls.Add(this.okbDownloadButton);
-      this.okbTabPage.Controls.Add(this.algorithmInstancesViewHost);
+      this.okbTabPage.Controls.Add(this.kbViewHost);
       this.okbTabPage.Location = new System.Drawing.Point(4, 22);
       this.okbTabPage.Name = "okbTabPage";
       this.okbTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.okbTabPage.Size = new System.Drawing.Size(538, 335);
+      this.okbTabPage.Size = new System.Drawing.Size(538, 306);
       this.okbTabPage.TabIndex = 5;
       this.okbTabPage.Text = "Knowledge Base";
       this.okbTabPage.UseVisualStyleBackColor = true;
       // 
-      // algorithmInstancesViewHost
-      // 
-      this.algorithmInstancesViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.algorithmInstancesViewHost.Caption = "View";
-      this.algorithmInstancesViewHost.Content = null;
-      this.algorithmInstancesViewHost.Enabled = false;
-      this.algorithmInstancesViewHost.Location = new System.Drawing.Point(3, 35);
-      this.algorithmInstancesViewHost.Name = "algorithmInstancesViewHost";
-      this.algorithmInstancesViewHost.ReadOnly = false;
-      this.algorithmInstancesViewHost.Size = new System.Drawing.Size(532, 297);
-      this.algorithmInstancesViewHost.TabIndex = 0;
-      this.algorithmInstancesViewHost.ViewsLabelVisible = true;
-      this.algorithmInstancesViewHost.ViewType = null;
+      // kbViewHost
+      // 
+      this.kbViewHost.Caption = "View";
+      this.kbViewHost.Content = null;
+      this.kbViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.kbViewHost.Enabled = false;
+      this.kbViewHost.Location = new System.Drawing.Point(3, 3);
+      this.kbViewHost.Name = "kbViewHost";
+      this.kbViewHost.ReadOnly = true;
+      this.kbViewHost.Size = new System.Drawing.Size(532, 300);
+      this.kbViewHost.TabIndex = 3;
+      this.kbViewHost.ViewsLabelVisible = true;
+      this.kbViewHost.ViewType = null;
       // 
       // problemInstancesTabPage
@@ -268,5 +244,5 @@
       this.problemInstancesTabPage.Name = "problemInstancesTabPage";
       this.problemInstancesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.problemInstancesTabPage.Size = new System.Drawing.Size(538, 335);
+      this.problemInstancesTabPage.Size = new System.Drawing.Size(538, 306);
       this.problemInstancesTabPage.TabIndex = 6;
       this.problemInstancesTabPage.Text = "Problem Instances";
@@ -275,6 +251,6 @@
       // problemInstancesView
       // 
-      this.problemInstancesView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.problemInstancesView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.problemInstancesView.Caption = "View";
@@ -284,5 +260,5 @@
       this.problemInstancesView.Name = "problemInstancesView";
       this.problemInstancesView.ReadOnly = false;
-      this.problemInstancesView.Size = new System.Drawing.Size(532, 298);
+      this.problemInstancesView.Size = new System.Drawing.Size(532, 269);
       this.problemInstancesView.TabIndex = 3;
       this.problemInstancesView.ViewsLabelVisible = true;
@@ -292,5 +268,5 @@
       // 
       this.instancesDropPanel.AllowDrop = true;
-      this.instancesDropPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.instancesDropPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.instancesDropPanel.BackColor = System.Drawing.Color.LightYellow;
@@ -326,4 +302,27 @@
       this.refreshMapButton.Click += new System.EventHandler(this.refreshMapButton_Click);
       // 
+      // progressPanel
+      // 
+      this.progressPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.progressPanel.Location = new System.Drawing.Point(0, 81);
+      this.progressPanel.Name = "progressPanel";
+      this.progressPanel.Size = new System.Drawing.Size(549, 332);
+      this.progressPanel.TabIndex = 2;
+      this.progressPanel.Visible = false;
+      // 
+      // okbDownloadButton
+      // 
+      this.okbDownloadButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.okbDownloadButton.Location = new System.Drawing.Point(6, 52);
+      this.okbDownloadButton.Name = "okbDownloadButton";
+      this.okbDownloadButton.Size = new System.Drawing.Size(518, 23);
+      this.okbDownloadButton.TabIndex = 1;
+      this.okbDownloadButton.Text = "Download from OKB";
+      this.okbDownloadButton.UseVisualStyleBackColor = true;
+      this.okbDownloadButton.Click += new System.EventHandler(this.okbDownloadButton_Click);
+      // 
       // openFileDialog
       // 
@@ -333,48 +332,30 @@
       this.openFileDialog.Title = "Open Optimizer";
       // 
-      // okbDownloadButton
-      // 
-      this.okbDownloadButton.Location = new System.Drawing.Point(6, 6);
-      this.okbDownloadButton.Name = "okbDownloadButton";
-      this.okbDownloadButton.Size = new System.Drawing.Size(146, 23);
-      this.okbDownloadButton.TabIndex = 1;
-      this.okbDownloadButton.Text = "Download from OKB";
-      this.okbDownloadButton.UseVisualStyleBackColor = true;
-      this.okbDownloadButton.Click += new System.EventHandler(this.okbDownloadButton_Click);
-      // 
-      // runsView
-      // 
-      this.runsView.Caption = "RunCollection View";
-      this.runsView.Content = null;
-      this.runsView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.runsView.Location = new System.Drawing.Point(3, 3);
-      this.runsView.Name = "runsView";
-      this.runsView.ReadOnly = false;
-      this.runsView.Size = new System.Drawing.Size(532, 329);
-      this.runsView.TabIndex = 1;
-      // 
-      // progressPanel
-      // 
-      this.progressPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.progressPanel.Location = new System.Drawing.Point(6, 35);
-      this.progressPanel.Name = "progressPanel";
-      this.progressPanel.Size = new System.Drawing.Size(526, 294);
-      this.progressPanel.TabIndex = 2;
-      this.progressPanel.Visible = false;
+      // algorithmStartButton
+      // 
+      this.algorithmStartButton.Location = new System.Drawing.Point(506, 5);
+      this.algorithmStartButton.Name = "algorithmStartButton";
+      this.algorithmStartButton.Size = new System.Drawing.Size(26, 23);
+      this.algorithmStartButton.TabIndex = 3;
+      this.algorithmStartButton.Text = "Start";
+      this.algorithmStartButton.UseVisualStyleBackColor = true;
+      this.algorithmStartButton.Click += new System.EventHandler(this.algorithmStartButton_Click);
       // 
       // ExpertSystemView
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.okbDownloadButton);
       this.Controls.Add(this.tabControl);
       this.Controls.Add(this.evaluationsLimitabel);
       this.Controls.Add(this.maxEvaluationsTextBox);
+      this.Controls.Add(this.progressPanel);
       this.Name = "ExpertSystemView";
       this.Size = new System.Drawing.Size(549, 413);
+      this.Controls.SetChildIndex(this.progressPanel, 0);
       this.Controls.SetChildIndex(this.maxEvaluationsTextBox, 0);
       this.Controls.SetChildIndex(this.evaluationsLimitabel, 0);
       this.Controls.SetChildIndex(this.tabControl, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.okbDownloadButton, 0);
       this.Controls.SetChildIndex(this.nameTextBox, 0);
       this.Controls.SetChildIndex(this.infoLabel, 0);
@@ -404,6 +385,4 @@
     private System.Windows.Forms.TabPage problemTabPage;
     private MainForm.WindowsForms.ViewHost problemViewHost;
-    private System.Windows.Forms.Button openProblemButton;
-    private System.Windows.Forms.Button newProblemButton;
     private System.Windows.Forms.TabPage algorithmTabPage;
     private MainForm.WindowsForms.ViewHost algorithmViewHost;
@@ -411,5 +390,4 @@
     private System.Windows.Forms.ComboBox suggestedInstancesComboBox;
     private System.Windows.Forms.TabPage okbTabPage;
-    private MainForm.WindowsForms.ViewHost algorithmInstancesViewHost;
     private System.Windows.Forms.TabPage problemInstancesTabPage;
     private System.Windows.Forms.Panel instancesDropPanel;
@@ -419,4 +397,6 @@
     private System.Windows.Forms.Button okbDownloadButton;
     private System.Windows.Forms.Panel progressPanel;
+    private MainForm.WindowsForms.ViewHost kbViewHost;
+    private System.Windows.Forms.Button algorithmStartButton;
   }
 }